/***************************************************************************
                          perl_parser.cpp  -  description
                             -------------------
    begin                : Apr 2 2003
    author               : 2003 Massimo Callegari
    email                : massimocallegari@yahoo.it
 ***************************************************************************/
 /***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "plugin_katesymbolviewer.h"

void KatePluginSymbolViewerView::parsePerlSymbols(void)
{
 if (!win->viewManager()->activeView())
     return;
 popup->changeItem( popup->idAt(2),i18n("Show Uses"));
 popup->changeItem( popup->idAt(3),i18n("Show Pragmas"));
 popup->changeItem( popup->idAt(4),i18n("Show Subroutines"));
 QString cl; // Current Line
 QString stripped;
 char comment = 0;
 QPixmap cls( ( const char** ) class_xpm );
 QPixmap sct( ( const char** ) struct_xpm );
 QPixmap mcr( ( const char** ) macro_xpm );
 QPixmap cls_int( ( const char** ) class_int_xpm );
 QListViewItem *node = NULL;
 QListViewItem *mcrNode = NULL, *sctNode = NULL, *clsNode = NULL;
 QListViewItem *lastMcrNode = NULL, *lastSctNode = NULL, *lastClsNode = NULL;
 Kate::Document *kv = win->viewManager()->activeView()->getDoc();
 //kdDebug(13000)<<"Lines counted :"<<kv->numLines()<<endl;
 if(treeMode)
  {
   mcrNode = new QListViewItem(symbols, symbols->lastItem(), i18n("Uses"));
   sctNode = new QListViewItem(symbols, symbols->lastItem(), i18n("Pragmas"));
   clsNode = new QListViewItem(symbols, symbols->lastItem(), i18n("Subroutines"));
   mcrNode->setPixmap(0, (const QPixmap &)mcr);
   sctNode->setPixmap(0, (const QPixmap &)sct);
   clsNode->setPixmap(0, (const QPixmap &)cls);
    if (expanded_on)
      {
       mcrNode->setOpen(TRUE);
       sctNode->setOpen(TRUE);
       clsNode->setOpen(TRUE);
      }
   lastMcrNode = mcrNode;
   lastSctNode = sctNode;
   lastClsNode = clsNode;
   symbols->setRootIsDecorated(1);
  }
 else
   symbols->setRootIsDecorated(0);

 for (unsigned int i=0; i<kv->numLines(); i++)
    {
     cl = kv->textLine(i);
     cl = cl.stripWhiteSpace();
     if(cl.at(0) == '#') continue;
     if(cl.find(QRegExp("^=")) >= 0) comment = 1;
     if(cl.find(QRegExp("^=cut$")) >= 0)
       {
        comment = 0;
        continue;
       }
     if (comment==1)
        continue;
     if(cl.find(QRegExp("^use +[A-Z]")) == 0 && macro_on)
       {
        QString stripped=cl.replace( QRegExp("^use +"), "" );
        //stripped=stripped.replace( QRegExp(";$"), "" ); // Doesn't work ??
        stripped = stripped.left(stripped.find(';'));
        if (treeMode)
          {
           node = new QListViewItem(mcrNode, lastMcrNode, stripped);
           lastMcrNode = node;
          }
        else 
           node = new QListViewItem(symbols, symbols->lastItem(), stripped);
        node->setPixmap(0, (const QPixmap &)mcr);
        node->setText(1, QString::number( i, 10));
       }
     if(cl.find(QRegExp("^use +[a-z]")) == 0 && struct_on)
       {
        QString stripped=cl.replace( QRegExp("^use +"), "" );
        stripped=stripped.replace( QRegExp(";$"), "" );
        if (treeMode)
          {
           node = new QListViewItem(sctNode, lastSctNode, stripped);
           lastMcrNode = node;
          }
        else
           node = new QListViewItem(symbols, symbols->lastItem(), stripped);
        node->setPixmap(0, (const QPixmap &)sct);
        node->setText(1, QString::number( i, 10));
       }
     if(cl.find(QRegExp ("^sub +(?!.+;)"))==0 && func_on)
       {
        QString stripped=cl.replace( QRegExp("^sub +"), "" );
        stripped=stripped.replace( QRegExp("[{;] *$"), "" );

        if (treeMode)
          {
           node = new QListViewItem(clsNode, lastClsNode, stripped);
           lastClsNode = node;
          }
        else
           node = new QListViewItem(symbols, symbols->lastItem(), stripped);
        if (stripped.at(0)=='_')
            node->setPixmap(0, (const QPixmap &)cls_int);
        else
           node->setPixmap(0, (const QPixmap &)cls);
        node->setText(1, QString::number( i, 10));
       }
    }
}



