/***************************************************************************
                          ruby_parser.cpp  -  description
                             -------------------
    begin                : May 9th 2007
    author               : 2007 Massimo Callegari
    email                : massimocallegari@yahoo.it
 ***************************************************************************/
 /***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "plugin_katesymbolviewer.h"

void KatePluginSymbolViewerView::parseRubySymbols(void)
{
 if (!win->viewManager()->activeView())
     return;
 popup->changeItem( popup->idAt(2),i18n("Show Globals"));
 popup->changeItem( popup->idAt(3),i18n("Show Methods"));
 popup->changeItem( popup->idAt(4),i18n("Show Classes"));
 QString cl; // Current Line
 QPixmap cls( ( const char** ) class_xpm );
 QPixmap mtd( ( const char** ) method_xpm );
 QPixmap mcr( ( const char** ) macro_xpm );

 int in_class = 0, state = 0, j;
 QString name;

 QListViewItem *node = NULL;
 QListViewItem *mcrNode = NULL, *mtdNode = NULL, *clsNode = NULL;
 QListViewItem *lastMcrNode = NULL, *lastMtdNode = NULL, *lastClsNode = NULL;
 Kate::Document *kv = win->viewManager()->activeView()->getDoc();
 //kdDebug(13000)<<"Lines counted :"<<kv->numLines()<<endl;
 if(treeMode)
   {
    clsNode = new QListViewItem(symbols, symbols->lastItem(), i18n("Classes"));
    clsNode->setPixmap(0, (const QPixmap &)cls);
    if (expanded_on)
      {
       clsNode->setOpen(TRUE);
      }
    lastClsNode = clsNode;
    lastMcrNode = mcrNode;
    mtdNode = clsNode;
    lastMtdNode = clsNode;
    symbols->setRootIsDecorated(1);
   }
 else
     symbols->setRootIsDecorated(0);

 for (unsigned int i=0; i<kv->numLines(); i++)
    {
     cl = kv->textLine(i);
     cl = cl.stripWhiteSpace();

     if (cl.find( QRegExp("^class [a-zA-Z0-9]+[^#]") ) >= 0)
       {
        name = cl.mid(6);
          if (func_on == true)
            {
             if (treeMode)
               {
                node = new QListViewItem(clsNode, lastClsNode, name);
                if (expanded_on) node->setOpen(TRUE);
                lastClsNode = node;
                mtdNode = lastClsNode;
                lastMtdNode = lastClsNode;
               }
             else node = new QListViewItem(symbols, symbols->lastItem(), name);
             node->setPixmap(0, (const QPixmap &)cls);
             node->setText(1, QString::number( i, 10));
            }
       }
     if (cl.find( QRegExp("^def [a-zA-Z_]+[^#]") ) >= 0 )
       {
        name = cl.mid(4);
        if (types_on == false)
          {
           name = name.left(name.find('('));
          }
        if (struct_on == true)
          {
           if (treeMode)
             {
              node = new QListViewItem(mtdNode, lastMtdNode, name);
              lastMtdNode = node;
             }
           else node = new QListViewItem(symbols, symbols->lastItem(), name);
           node->setPixmap(0, (const QPixmap &)mtd);
           node->setText(1, QString::number( i, 10));
          }
       }
    }

}



